/***************************************************************************
 *  cmemorypanel.h
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _CMEMORYPANEL_H
#define _CMEMORYPANEL_H

#ifndef MEMORYPANEL_H
#include "memorypanel.h"
#endif

#ifndef CMEMORY_H
#include "cmemory.h"
#endif

#ifndef _I8052_H
#include "i8052.h"
#endif

/*
 * CMemoryPanel
 */

class Pcmon;

#define EDLEN       30
#define ASMPOS      13
#define HINIBPOS    7
#define CHARPOS     9

typedef char edline [EDLEN];

class CMemoryPanel : public MemoryPanel {

	i8052 *processor;
	SFRMemory *sfr;

	unsigned nLines;
	edline *Ists;
	unsigned *Next;
	unsigned *Prev;
	edline EdBuf;
	unsigned CIstLen;
	bool IstChanged;

	Gtk::Menu*    popupMenuSet;
	Gtk::Menu*    popupMenuReset;
	/* Occorre metterlo nella classe, perche' i menu che contiene vengono usati dopo */
	Glib::RefPtr<Gtk::UIManager> m_refUIManager;
	Glib::RefPtr<Gtk::ActionGroup> m_refActionGroup;


	virtual void showLine (Glib::RefPtr<Gdk::Window> win, unsigned line, int y);
	virtual bool on_expose_event (GdkEventExpose *event);
	virtual unsigned curPos ();
	virtual bool on_button_press_event (GdkEventButton *);

	void ChangeIst (void);
	virtual bool on_configure_event (GdkEventConfigure *event);
	bool Asm (void);

	void menuAddBk ();
	void menuDelBk ();
	
	void RefreshLines (int n);
	
	void DisassView (void);
	virtual void key (int k);
	void position (unsigned address, bool exact);
public:
	virtual void goTo (unsigned where);
	void menuRunTo ();
	virtual void show (unsigned address);
	CMemoryPanel (i8052 *proc, Pcmon *p);
};

#endif /* _CMEMORYPANEL_H */
