/***************************************************************************
 *  finddialog.h
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _FINDDIALOG_H
#define _FINDDIALOG_H


class EditWindow;
class EditBuffer;

class FindDialog : public Gtk::Dialog {
	Glib::RefPtr<EditBuffer> parent;

	int replace;
	int endSearch;

	labelField testo;
  
	GSList gFromWhere;
	Gtk::RadioButton::Group gr;
	Gtk::RadioButton fromCursor;
	Gtk::RadioButton fromStart;
	Gtk::RadioButton selectOnly;

	Gtk::CheckButton CaseSensitive;
	Gtk::CheckButton RegularExpression;

	labelField toTesto;

	Gtk::Button Cerca;
	Gtk::Button Cambia;
	Gtk::Button CambiaTutti;
	Gtk::Button annulla;

	virtual bool on_delete_event (GdkEventAny *e);
	void cancelButton ();
	void FindButton ();
	void ReplaceButton ();
	void ReplaceAll ();
public :
	FindDialog ();
	void doFind (Glib::RefPtr<EditBuffer> editor);
	void reDoFind (Glib::RefPtr<EditBuffer> editor);
	void setFrontWin (Glib::RefPtr<EditBuffer> editor);
};

// class ErrorDialog : public Gtk::Dialog {
class ErrorDialog : public Gtk::Window {
	EditWindow *parent;

	//Tree model columns:
	class errColumns : public Gtk::TreeModel::ColumnRecord
	{
	public:

		errColumns()
			{ add(m_col_line); add(m_col_type); add(m_col_error); }

		Gtk::TreeModelColumn<unsigned int> m_col_line;
		Gtk::TreeModelColumn<Glib::ustring> m_col_type;
		Gtk::TreeModelColumn<Glib::ustring> m_col_error;
	};

	errColumns m_Columns;

	// Box del dialog
	Gtk::VBox vbox;
	Gtk::HBox action;

	Gtk::ScrolledWindow scroller;
	Gtk::TreeView view;
	Glib::RefPtr<Gtk::ListStore> errList;
	Glib::RefPtr<Gtk::TreeSelection> refTreeSelection;

	Gtk::Button CloseButton;
	Gtk::Button GoTo;

	virtual bool on_delete_event (GdkEventAny *e);
	void button_press_event (GdkEventButton *b);
	void GoToButton ();
	void doSelect (bool raise);
	void select_child();
	void CancelButton ();

public:
	ErrorDialog (EditWindow *p);
	void closeErrors (EditWindow *p) { if (p == parent) { CancelButton (); } };
	void ClearErrors ();
	bool hasErrors ();
	void AddError (char *s);
	void display ();
};

#endif /* _FINDDIALOG_H */
