/***************************************************************************
 *  serial.h
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _SERIAL_H
#define _SERIAL_H

#include <pthread.h>
#include <termios.h>

class Serial_Container;

class Serial {
	Serial_Container *interface;
	// Materiale per comunicazione con scheda
	struct termios saved_attributes;
	int com;
	char *comname;
	pthread_t receiver_thread;
	static void *receiver_wrapper (void *th);
	int boardPipe [2];
	bool usePipe;
	bool connected;
	void *receiver ();
	void noline ();

public:
	int schPrompt () { if (schWaitc ('*')) return -1; schRelease (); return 0; };
	int schGetc ();
	int schGets (char *str,int max);
	int schWaitc (char c);
	void schPuts (const char *s);
	void schPutc (const char c);
	void schSendc (const char c);
	void schSends (const char *c);
	void schGet () { usePipe = true; };
	void schRelease () { usePipe = false; };
	bool schIsWorking () { return usePipe; };
	bool isConnected () { return connected; }
	void setConnected (bool v) { connected = v;}
  
	Serial (char *device, Serial_Container *p);
	~Serial ();
};

/* "intefacia" stile Java */
class Serial_Container {
public:
	static Serial *s;
	virtual bool isRunning () = 0;
	virtual void setRunning (bool v) = 0;
	virtual void setConnectedMessage (const char*s) = 0;
	virtual void setRunningMessage (const char*s) = 0;
	virtual void setMessage (const char*s) = 0;
	virtual void startEmulation () = 0;
	virtual void tPutc (char c) = 0;
	virtual void reload () = 0;
};

#endif /* _SERIAL_H */
