/***************************************************************************
 *  ppiwin.cc
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 * Gal memoria: BS
 * J2 2-3 -> Ram IC8 32K
 * J3 2-3 -> Rom IC7 32K
 * J4 1-2
 * J5 2-3
 * Mappaggio memoria: BS-1
 *  Eprom: 0000-7fff
 *  RAM:   8000-f7ff
 *  I/O:   f800-ffff
 *	PPI 8255:    fa00
 *	Tim a 8254:  fa40
 *	Tim b 8254:  fa80
 *	RTC:	     fac0
 *	Bus:	     fb00
 */

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <glib/gmacros.h>
#include <glib.h>
#include <gtkmm.h>
#include <libgnomemm.h>

#ifndef _I8052_H
#include "i8052.h"
#endif

#include "ppiwin.h"

bool ppiwin::on_delete_event (GdkEventAny *e)
{
  hide ();
  return true;
}

void ppiwin::redraw ()
{
  PPI.redraw ();
}

ppiwin::ppiwin (i8052 *p)
{
	set_title ("TIO 16");

	add (PPI);
	PPI.set_size_request (295,150);
	set_sensitive (true);

	p -> setPPI (&PPI);
	
	set_events (Gdk::KEY_PRESS_MASK);
	show_all ();
}
