/***************************************************************************
 *  register.cc
 *
 *  Sun Nov 14 10:49:20 2004
 *  Copyright  2004 Ing. Stefano Salvi
 *  Email stefano@salvi.mn.it
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <glib/gmacros.h>
#include <glib.h>
#include <gtkmm.h>
#include <libgnomemm.h>

#include "pcmon.h"
#include "pc.h"
#include "sfr.h"
#include "dialogs.h"

/* Register */

void Register::redraw ()
{
char buf [6];
  prgChanging = true;
  sprintf (buf,(r->getValue() || !noZero) ? "%x" : "---", r->getValue());
  set_text (buf);
  prgChanging = false;
}

void Register::Changed ()
{
char buf [20];

	if (prgChanging) {
    	return;
	}
	get_text (buf,19);
	r -> setValue (strtol (buf,NULL,16));
}

Register::Register (char *label, int is8Bit, int no0, HRegister *reg) :
  labelField (label)
{
	r = reg;
	r->setRefresh(this);
	testo.set_size_request (is8Bit ? 30 : 55, 18);
	noZero = no0;
	getText()->signal_changed().connect(sigc::mem_fun(*this,&Register::Changed));
}
